## paho.mqtt.cpp 1.2.0

=== CMakeLists.txt ===
# CMakeLists.txt
#
# Top-level CMake file for the Paho C++ library.
#
#*******************************************************************************
# This is part of the Paho MQTT C++ client library.
#
# Copyright (c) 2016-2017, Guilherme Maciel Ferreira
# Copyright (c) 2017, Frank Pagliughi
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# and Eclipse Distribution License v1.0 which accompany this distribution.
# 
# The Eclipse Public License is available at
#   http://www.eclipse.org/legal/epl-v10.html
# and the Eclipse Distribution License is available at
#   http://www.eclipse.org/org/documents/edl-v10.php.
# 
# Contributors:
#   Guilherme Maciel Ferreira - initial version
#   Frank Pagliughi
#*******************************************************************************/

## Note: on OS X you should install XCode and the associated command-line tools

## cmake flags
cmake_minimum_required(VERSION 3.5)

## project name
project("paho-mqtt-cpp" 
    VERSION "1.2.0"
    LANGUAGES CXX
)

## --- Build options ---

if(WIN32)
  option(PAHO_BUILD_STATIC "Build static library" TRUE)
  option(PAHO_BUILD_SHARED "Build shared library (DLL)" FALSE)
  option(PAHO_WITH_SSL "Build SSL-enabled library" FALSE)
else()
  option(PAHO_BUILD_STATIC "Build static library" FALSE)
  option(PAHO_BUILD_SHARED "Build shared library" TRUE)
  option(PAHO_WITH_SSL "Build SSL-enabled library" TRUE)
  option(PAHO_BUILD_DEB_PACKAGE "Build debian package" FALSE)
endif()

option(PAHO_BUILD_SAMPLES "Build sample programs" FALSE)
option(PAHO_BUILD_TESTS "Build tests" FALSE)
option(PAHO_BUILD_DOCUMENTATION "Create and install the API documentation (requires Doxygen)" FALSE)

## --- C++11 build flags ---

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Generate position-independent code (-fPIC on UNIX)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# --- System Libraries ---

include(GNUInstallDirs)

if(WIN32)
	  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    set(LIBS_SYSTEM ws2_32)
elseif(UNIX)
    set(LIBS_SYSTEM c stdc++)
endif()

## --- Build directories ---

# For the paho_mqtt_c module
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
add_subdirectory(src)

# --- Documentation ---

if(PAHO_BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

# --- Default library for samples and unit tests ---

if(PAHO_BUILD_SHARED)
    set(PAHO_CPP_LIB paho-mqttpp3)
else()
    set(PAHO_CPP_LIB paho-mqttpp3-static)
endif()

# --- Sample Apps ---

if(PAHO_BUILD_SAMPLES)
    add_subdirectory(src/samples)
endif()

# --- Unit Tests ---

if(PAHO_BUILD_TESTS)
    add_subdirectory(test/unit)
endif()

## --- Packaging settings ---

if(WIN32)
    set(CPACK_GENERATOR "ZIP")
elseif(UNIX)
    if(PAHO_BUILD_DEB_PACKAGE)
        set(CPACK_GENERATOR "DEB")
        include(cmake/CPackDebConfig.cmake)
    else()
        set(CPACK_GENERATOR "TGZ")
	endif()
endif()

include(CPack)
add_subdirectory(cmake)

=== cmake/CMakeLists.txt ===
set(package_name PahoMqttCpp)
configure_file(${package_name}Config.cmake.in ${package_name}Config.cmake @ONLY)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/${package_name}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion) # TODO

export(EXPORT ${package_name}
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${package_name}Targets.cmake"
    NAMESPACE ${package_name}::)

install(EXPORT ${package_name} DESTINATION lib/cmake/${package_name}
    FILE ${package_name}Targets.cmake
    NAMESPACE ${package_name}::)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${package_name}Config.cmake"
    FindPahoMqttC.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/${package_name}ConfigVersion.cmake"
    DESTINATION lib/cmake/${package_name})

=== doc/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2016
# 
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v1.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v10.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Guilherme Maciel Ferreira - initial version
#*******************************************************************************/

## documentation settings
find_package(Doxygen)
if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
endif()

set(DOXYTARGETS)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)

set(DOXYFILE_SRC Doxyfile.cmake)
set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE_SRC})

configure_file(${DOXYFILE_SRC} ${DOXYFILE} @ONLY)
add_custom_target(
    ${DOXYFILE_SRC}.target
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM
)
set(DOXYTARGETS ${DOXYTARGETS} ${DOXYFILE_SRC}.target)

add_custom_target(doc ALL DEPENDS ${DOXYTARGETS})

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc DESTINATION share)

=== src/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Paho C++ core library.
#
# This is part of the Paho MQTT C++ client library.
#

#*******************************************************************************
# Copyright (c) 2016-2017, Guilherme Maciel Ferreira
# Copyright (c) 2017-2018, Frank Pagliughi
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v1.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v10.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Guilherme Maciel Ferreira - initial version
#     Frank Pagliughi - made the shared library optional
#*******************************************************************************/

find_package(PahoMqttC REQUIRED)

# --- The headers ---

add_subdirectory(mqtt)

## --- Library dependencies ---

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

#set(LIBS_SYSTEM Threads::Threads)
#if(WIN32)
#    string(APPEND LIBS_SYSTEM " ws2_32")
#endif()

## --- Use object library to optimize compilation ---

add_library(paho-cpp-objs OBJECT
  async_client.cpp
  client.cpp
  connect_options.cpp
  create_options.cpp    
  disconnect_options.cpp
  iclient_persistence.cpp
  message.cpp
  properties.cpp
  response_options.cpp
  ssl_options.cpp
  string_collection.cpp
  subscribe_options.cpp
  token.cpp
  topic.cpp
  will_options.cpp
)

## install the shared library
#install(TARGETS paho-cpp-objs EXPORT PahoMqttCpp
#    OBJECTS DESTINATION ${CMAKE_INSTALL_LIBDIR}
#)

# Object libraries can't use target_link_libraries in order to take advantage
# of transitive usage requirements until CMake 3.12. This is a workaround:
#target_include_directories(OBJS PRIVATE ${PAHO_MQTT_C_INCLUDE_DIRS})

target_include_directories(paho-cpp-objs 
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>
    PRIVATE 
        ${PAHO_MQTT_C_INCLUDE_DIRS}
        src
)


## --- Build the shared library, if requested ---

if(PAHO_BUILD_SHARED)
    ## create the shared library
    add_library(paho-mqttpp3 SHARED $<TARGET_OBJECTS:paho-cpp-objs>)

    ## add dependencies to the shared library
    target_link_libraries(paho-mqttpp3
        PRIVATE ${LIBS_SYSTEM}
        PUBLIC PahoMqttC::PahoMqttC Threads::Threads)

    # It would be nice to exort the include paths from the obj lib, but we
    # get an export error. Perhaps in a future version?
    # 
    # CMake Error: install(EXPORT "PahoMqttCpp" ...) includes target "paho-mqttpp3"
    #   which requires target "paho-cpp-objs" that is not in the export set.

    #target_include_directories(paho-mqttpp3 PUBLIC 
    #    $<TARGET_PROPERTY:paho-cpp-objs,INCLUDE_DIRECTORIES>
    #)

    target_include_directories(paho-mqttpp3 PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    ## set the shared library soname
    set_target_properties(paho-mqttpp3 PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR})

    ## install the shared library
    install(TARGETS paho-mqttpp3 EXPORT PahoMqttCpp
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

## --- Build static version of the library, if requested ---

if(PAHO_BUILD_STATIC)
    ## create the static library
    add_library(paho-mqttpp3-static STATIC $<TARGET_OBJECTS:paho-cpp-objs>)

    ## add dependencies to the shared library
    target_link_libraries(paho-mqttpp3-static
        PRIVATE ${LIBS_SYSTEM}
        PUBLIC PahoMqttC::PahoMqttC Threads::Threads)

    target_include_directories(paho-mqttpp3-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    ## install the static library
    install(TARGETS paho-mqttpp3-static EXPORT PahoMqttCpp
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    ## Let the archive use the same name as the shared lib on *nix systems
    if(UNIX)
        set_target_properties(paho-mqttpp3-static PROPERTIES OUTPUT_NAME paho-mqttpp3)
    endif()
endif()

=== src/mqtt/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2016-2018
# 
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v1.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v10.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Guilherme Maciel Ferreira - initial version
#     Frank Pagliughi
#*******************************************************************************/

install(
    FILES
        async_client.h
        buffer_ref.h
        buffer_view.h
        callback.h
        client.h
        connect_options.h
        create_options.h
        delivery_token.h
        disconnect_options.h
        exception.h
        iaction_listener.h
        iasync_client.h
        iclient_persistence.h
        message.h
        properties.h
        response_options.h
        server_response.h
        ssl_options.h
        string_collection.h
        subscribe_options.h
        thread_queue.h
        token.h
        topic.h
        types.h
        will_options.h
    DESTINATION 
        include/mqtt
)

=== src/samples/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Paho C++ sample applications.
#
#*******************************************************************************
# This is part of the Paho MQTT C++ client library.
#
# Copyright (c) 2016-2019
# 
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# and Eclipse Distribution License v1.0 which accompany this distribution.
# 
# The Eclipse Public License is available at
#   http://www.eclipse.org/legal/epl-v10.html
# and the Eclipse Distribution License is available at
#   http://www.eclipse.org/org/documents/edl-v10.php.
# 
# Contributors:
#   Guilherme Maciel Ferreira - initial version
#   Frank Pagliughi - Updates for new samples
#*******************************************************************************/

## Note: on OS X you should install XCode and the associated command-line tools

## --- Library dependencies ---

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

## include directories
#include_directories(${CMAKE_CURRENT_SOURCE_DIR})

## binary files
add_executable(async_publish async_publish.cpp)
add_executable(async_publish_time async_publish_time.cpp)
add_executable(async_subscribe async_subscribe.cpp)
add_executable(async_consume async_consume.cpp)
add_executable(sync_publish sync_publish.cpp)
add_executable(sync_consume sync_consume.cpp)
add_executable(sync_consume_v5 sync_consume_v5.cpp)
add_executable(sync_reconnect sync_reconnect.cpp)
add_executable(data_publish data_publish.cpp)
add_executable(topic_publish topic_publish.cpp)
add_executable(rpc_math_cli rpc_math_cli.cpp)
add_executable(rpc_math_srvr rpc_math_srvr.cpp)
add_executable(mqttpp_chat mqttpp_chat.cpp)
add_executable(multithr_pub_sub multithr_pub_sub.cpp)
add_executable(ws_publish ws_publish.cpp)
add_executable(pub_speed_test pub_speed_test.cpp)

## link binaries
target_link_libraries(async_publish ${PAHO_CPP_LIB})
target_link_libraries(async_publish_time ${PAHO_CPP_LIB})
target_link_libraries(async_subscribe ${PAHO_CPP_LIB})
target_link_libraries(async_consume ${PAHO_CPP_LIB})
target_link_libraries(sync_publish ${PAHO_CPP_LIB})
target_link_libraries(sync_consume ${PAHO_CPP_LIB})
target_link_libraries(sync_consume_v5 ${PAHO_CPP_LIB})
target_link_libraries(sync_reconnect ${PAHO_CPP_LIB})
target_link_libraries(data_publish ${PAHO_CPP_LIB})
target_link_libraries(topic_publish ${PAHO_CPP_LIB})
target_link_libraries(rpc_math_cli ${PAHO_CPP_LIB})
target_link_libraries(rpc_math_srvr ${PAHO_CPP_LIB})
target_link_libraries(mqttpp_chat ${PAHO_CPP_LIB})
target_link_libraries(multithr_pub_sub ${PAHO_CPP_LIB})
target_link_libraries(ws_publish ${PAHO_CPP_LIB})
target_link_libraries(pub_speed_test ${PAHO_CPP_LIB})

set(INSTALL_TARGETS
	async_publish
	async_publish_time
	async_subscribe
	async_consume
	sync_publish
  sync_consume
  sync_consume_v5
  sync_reconnect
	data_publish
	rpc_math_cli
	rpc_math_srvr
	mqttpp_chat
  topic_publish
  multithr_pub_sub
  ws_publish
	pub_speed_test
)

if(PAHO_WITH_SSL)
	## SSL binary files
	add_executable(ssl_publish ssl_publish.cpp)

	## link SSL binaries
	target_link_libraries(ssl_publish ${PAHO_CPP_LIB})

	set(INSTALL_TARGETS
		${INSTALL_TARGETS}
		ssl_publish
	)

	add_definitions(-DOPENSSL)
endif()

## install binaries
install(TARGETS ${INSTALL_TARGETS} EXPORT PahoMqttCppSamples
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
)

=== test/unit/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Catch2 unit tests in the Eclipse Paho C++ library.
#

#*******************************************************************************
# Copyright (c) 2019 Frank Pagliughi <fpagliughi@mindspring.com>
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v1.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v10.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Frank Pagliughi - Initial implementation
#*******************************************************************************/

find_package(Catch2 REQUIRED)

# --- For apps that use threads ---

#set(THREADS_PREFER_PTHREAD_FLAG ON)
#find_package(Threads REQUIRED)

# --- Executables ---

add_executable(unit_tests unit_tests.cpp
  test_async_client.cpp
  test_buffer_ref.cpp
  test_client.cpp
  test_connect_options.cpp
  test_create_options.cpp
  test_disconnect_options.cpp
	test_exception.cpp
  test_message.cpp
  test_persistence.cpp
  test_properties.cpp
  test_response_options.cpp
  test_string_collection.cpp
  test_token.cpp
  test_topic.cpp
  test_will_options.cpp
)

if(PAHO_WITH_SSL)
  target_sources(unit_tests PUBLIC 
    ${CMAKE_CURRENT_SOURCE_DIR}/test_ssl_options.cpp
  )
endif()

# --- Link for executables ---

message(STATUS "Using library for unit tests: ${PAHO_CPP_LIB}")

# .. Threads::Threads)
target_link_libraries(unit_tests ${PAHO_CPP_LIB} Catch2::Catch2)

include(CTest)
include(Catch)

catch_discover_tests(unit_tests)

=== debian/changelog ===
paho.mqtt.cpp (1.2.0-2) unstable; urgency=low

  * d/control: remove redundant Build-Depends on debhelper

 -- Matthias Klein <matthias@extraklein.de>  Sun, 28 Feb 2021 10:48:19 +0100

paho.mqtt.cpp (1.2.0-1) unstable; urgency=low

  * Initial release. Closes: #977740

 -- Matthias Klein <matthias@extraklein.de>  Tue, 09 Feb 2021 06:37:43 +0100

=== debian/control ===
Source: paho.mqtt.cpp
Section: libs
Priority: optional
Maintainer: Matthias Klein <matthias@extraklein.de>
Build-Depends: debhelper-compat (= 13), cmake, libssl-dev, libpaho-mqtt-dev (>= 1.3.8)
Standards-Version: 4.5.1
Homepage: https://github.com/eclipse/paho.mqtt.cpp/
Vcs-Browser: https://salsa.debian.org/matthiasklein/paho.mqtt.cpp
Vcs-Git: https://salsa.debian.org/matthiasklein/paho.mqtt.cpp.git

Package: libpaho-mqttpp3-1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Eclipse Paho MQTT C++ Client Library - shared libraries
 This library enables C++11 applications to connect to an MQTT broker,
 publish messages to the broker, and to subscribe to topics and receive
 published messages.
 .
 This package contains the shared library.

Package: libpaho-mqttpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpaho-mqttpp3-1 (= ${binary:Version}), ${misc:Depends}
Description: Eclipse Paho MQTT C++ Client Library - development files
 This library enables C++11 applications to connect to an MQTT broker,
 publish messages to the broker, and to subscribe to topics and receive
 published messages.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  

override_dh_auto_configure:
	dh_auto_configure -- \
        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
        -DPAHO_BUILD_SHARED=TRUE -DPAHO_WITH_SSL=TRUE
        -DPAHO_BUILD_STATIC=FALSE -DPAHO_BUILD_DOCUMENTATION=FALSE \
        -DPAHO_BUILD_SAMPLES=FALSE -DPAHO_BUILD_TESTS=FALSE \
        -DPAHO_BUILD_DEB_PACKAGE=FALSE

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?\/)?v?(\d[\d.]*)\.tar\.gz/${PACKAGE}_\$1.orig.tar.gz/" \
    https://github.com/eclipse/paho.mqtt.cpp/tags (?:.*?\/)?v?(\d[\d.]*)\.tar\.gz

## paho.mqtt.cpp 1.5.0

=== debian/changelog ===
paho.mqtt.cpp (1.5.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Remove field Section on binary package libpaho-mqttpp3-1 that duplicates
    source.

  [ Roman Ondráček ]
  * New upstream version 1.5.0 (Closes: #1094579)
  * d/control: update standards version to 4.7.0
  * d/patches: update CMake targets install path patch
  * d/watch: update to version 4
  * d/lintian-overrides: add source lintian overrides
  * d/upstream/metadata: add missing upstream metadata entries
  * d/salsa-ci.yml: enable Salsa CI
  * d/rules: add build of documentation, static library and tests
  * d/control: update the package maintainer to Roman Ondráček
    (Closes: #1095083)

 -- Roman Ondráček <mail@romanondracek.cz>  Mon, 03 Feb 2025 23:40:48 +0100

## paho.mqtt.cpp 1.5.1

=== CMakeLists.txt ===
# CMakeLists.txt
#
# Top-level CMake file for the Paho C++ library.
#
#*******************************************************************************
# This is part of the Paho MQTT C++ client library.
#
# Copyright (c) 2017-2025, Frank Pagliughi
# Copyright (c) 2016-2017, Guilherme Maciel Ferreira
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v2.0
# and Eclipse Distribution License v1.0 which accompany this distribution.
# 
# The Eclipse Public License is available at
#   http://www.eclipse.org/legal/epl-v20.html
# and the Eclipse Distribution License is available at
#   http://www.eclipse.org/org/documents/edl-v10.php.
# 
# Contributors:
#   Guilherme Maciel Ferreira - initial version
#   Frank Pagliughi
#*******************************************************************************/

cmake_minimum_required(VERSION 3.13)

project(PahoMqttCpp VERSION "1.5.1")

## --- Build options ---

if(WIN32)
    option(PAHO_BUILD_STATIC "Build static library" TRUE)
    option(PAHO_BUILD_SHARED "Build shared library (DLL)" FALSE)
    option(PAHO_WITH_SSL "Build SSL-enabled library" FALSE)
else()
    option(PAHO_BUILD_STATIC "Build static library" FALSE)
    option(PAHO_BUILD_SHARED "Build shared library" TRUE)
    option(PAHO_WITH_SSL "Build SSL-enabled library" TRUE)
    option(PAHO_BUILD_DEB_PACKAGE "Build debian package" FALSE)
endif()

option(PAHO_BUILD_SAMPLES "Build sample/example programs" FALSE)
option(PAHO_BUILD_EXAMPLES "Build sample/example programs" FALSE)
option(PAHO_BUILD_TESTS "Build tests (requires Catch2)" FALSE)
option(PAHO_BUILD_DOCUMENTATION "Create and install the API documentation (requires Doxygen)" FALSE)
option(PAHO_WITH_MQTT_C "Build Paho C from the internal GIT submodule." FALSE)

if(NOT PAHO_BUILD_SHARED AND NOT PAHO_BUILD_STATIC)
    message(FATAL_ERROR "You must set either PAHO_BUILD_SHARED, PAHO_BUILD_STATIC, or both")
endif()

## --- Find Paho C or build it, if reqested ---

if(PAHO_WITH_SSL)
    find_package(OpenSSL REQUIRED)
    set(PAHO_MQTT_C_LIB eclipse-paho-mqtt-c::paho-mqtt3as)
else()
    set(PAHO_MQTT_C_LIB eclipse-paho-mqtt-c::paho-mqtt3a)
endif()

if(PAHO_WITH_MQTT_C)
    message(STATUS "Paho C: Bundled")

    ## Build the Paho C library from the submodule
    set(PAHO_ENABLE_TESTING FALSE CACHE BOOL "No Paho C tests")
    set(PAHO_HIGH_PERFORMANCE TRUE CACHE BOOL "Paho C high performance")
    if(NOT WIN32)
        set(PAHO_WITH_UNIX_SOCKETS TRUE CACHE BOOL "Support for Unix-domain sockets")
    endif()

    add_subdirectory(${PROJECT_SOURCE_DIR}/externals/paho-mqtt-c)

    ## Alias namespace so that the full names can be used with the subdir.
    if(PAHO_BUILD_SHARED)
        add_library(eclipse-paho-mqtt-c::paho-mqtt3a ALIAS paho-mqtt3a)
        list(APPEND PAHO_MQTT_C_LIBS paho-mqtt3a)
        if(PAHO_WITH_SSL)
            add_library(eclipse-paho-mqtt-c::paho-mqtt3as ALIAS paho-mqtt3as)
            list(APPEND PAHO_MQTT_C_LIBS paho-mqtt3as)
        endif()
    endif()

    if(PAHO_BUILD_STATIC)
        add_library(eclipse-paho-mqtt-c::paho-mqtt3a-static ALIAS paho-mqtt3a-static)
        list(APPEND PAHO_MQTT_C_LIBS paho-mqtt3a-static)
        if(PAHO_WITH_SSL)
            add_library(eclipse-paho-mqtt-c::paho-mqtt3as-static ALIAS paho-mqtt3as-static)
            list(APPEND PAHO_MQTT_C_LIBS paho-mqtt3as-static)
        endif()
    endif()

    ## install paho.mqtt.c library (appending to PahoMqttCpp export)
    install(TARGETS ${PAHO_MQTT_C_LIBS}
        EXPORT PahoMqttCpp
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
else()
    find_package(eclipse-paho-mqtt-c REQUIRED)
endif()

# --- System Details ---

include(GNUInstallDirs)

if(WIN32)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    set(LIBS_SYSTEM ws2_32)
endif()

# --- The headers ---

add_subdirectory(include/mqtt)

# For the paho_mqtt_c module
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
add_subdirectory(src)

# --- Documentation ---

if(PAHO_BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

# --- Example Apps ---

if(PAHO_BUILD_SAMPLES OR PAHO_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# --- Unit Tests ---

if(PAHO_BUILD_TESTS)
    enable_testing()
    add_subdirectory(test/unit)
endif()

## --- Packaging settings ---

if(WIN32)
    set(CPACK_GENERATOR "ZIP")
elseif(UNIX)
    if(PAHO_BUILD_DEB_PACKAGE)
        set(CPACK_GENERATOR "DEB")
        include(cmake/CPackDebConfig.cmake)
    else()
        set(CPACK_GENERATOR "TGZ")
	endif()
endif()

include(CPack)

# --- Export CMake TARGETS ---

add_subdirectory(cmake)

=== cmake/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake export file for the Paho C++ library.
#
#*******************************************************************************
# This is part of the Paho MQTT C++ client library.
#
# Copyright (c) 2017-2023, Frank Pagliughi
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v2.0
# and Eclipse Distribution License v1.0 which accompany this distribution.
#
# The Eclipse Public License is available at
#   http://www.eclipse.org/legal/epl-v20.html
# and the Eclipse Distribution License is available at
#   http://www.eclipse.org/org/documents/edl-v10.php.
#*******************************************************************************/

set(package_name PahoMqttCpp)
configure_file(${package_name}Config.cmake.in ${package_name}Config.cmake @ONLY)

include(CMakePackageConfigHelpers)

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${package_name}ConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
)

export(EXPORT ${package_name}
  FILE "${CMAKE_CURRENT_BINARY_DIR}/${package_name}Targets.cmake"
  NAMESPACE ${package_name}::
)

install(EXPORT ${package_name}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${package_name}
  FILE ${package_name}Targets.cmake
  NAMESPACE ${package_name}::
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${package_name}Config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${package_name}ConfigVersion.cmake"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${package_name}
)

=== examples/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Paho C++ example applications.
#
#*******************************************************************************
# This is part of the Paho MQTT C++ client library.
#
# Copyright (c) 2016-2024
# 
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v2.0
# and Eclipse Distribution License v1.0 which accompany this distribution.
# 
# The Eclipse Public License is available at
#   http://www.eclipse.org/legal/epl-v20.html
# and the Eclipse Distribution License is available at
#   http://www.eclipse.org/org/documents/edl-v10.php.
# 
# Contributors:
#   Guilherme Maciel Ferreira - initial version
#   Frank Pagliughi - Updates for new samples
#*******************************************************************************/

## --- Library dependencies ---

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# The example applications
set(EXECUTABLES
    async_publish
    async_publish_time
    async_subscribe
    async_consume
    async_consume_v5
    async_message_consume
    async_message_consume_v5
    data_publish
    mqttpp_chat
    multithr_pub_sub
    pub_speed_test
    rpc_math_cli
    rpc_math_srvr
    server_props_v5
    sync_publish
    sync_consume
    sync_consume_v5
    sync_reconnect
    topic_publish
    ws_publish
)

# These will only be built if SSL selected
if(PAHO_WITH_SSL)
    set(SSL_EXECUTABLES ssl_publish)
endif()

## Build the example apps
foreach(EXECUTABLE ${EXECUTABLES} ${SSL_EXECUTABLES})
    add_executable(${EXECUTABLE} ${EXECUTABLE}.cpp)
    target_link_libraries(${EXECUTABLE} PahoMqttCpp::paho-mqttpp3)

    set_target_properties(${EXECUTABLE} PROPERTIES
        CXX_STANDARD 17
        CXX_STANDARD_REQUIRED ON
        CXX_EXTENSIONS OFF
    )

    if(PAHO_BUILD_SHARED)
        target_compile_definitions(${EXECUTABLE} PRIVATE PAHO_MQTTPP_IMPORTS)
    endif()
endforeach()

## Extra configuration for the SSL/TLS examples, if selected
foreach(EXECUTABLE ${SSL_EXECUTABLES})
    target_compile_definitions(${EXECUTABLE} PUBLIC OPENSSL)
endforeach()

## install binaries
include(GNUInstallDirs)

install(TARGETS ${EXECUTABLES} ${SSL_EXECUTABLES}
    EXPORT PahoMqttCppSamples
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Paho C++ core library.
#
# This is part of the Paho MQTT C++ client library.
#

#*******************************************************************************
# Copyright (c) 2016-2017, Guilherme Maciel Ferreira
# Copyright (c) 2017-2024, Frank Pagliughi
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v20.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Guilherme Maciel Ferreira - initial version
#     Frank Pagliughi - made the shared library optional
#*******************************************************************************/

## --- Library dependencies ---

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

## --- Use object library to optimize compilation ---

set(COMMON_SRC
    async_client.cpp
    client.cpp
    connect_options.cpp
    create_options.cpp    
    disconnect_options.cpp
    iclient_persistence.cpp
    message.cpp
    properties.cpp
    reason_code.cpp
    response_options.cpp
    server_response.cpp
    ssl_options.cpp
    string_collection.cpp
    token.cpp
    topic.cpp
    will_options.cpp
)

## --- Build the shared library, if requested ---

if(PAHO_BUILD_SHARED)
    message(STATUS "Creating shared library")

    ## Create the shared library
    add_library(paho-mqttpp3-shared SHARED ${COMMON_SRC})
    list(APPEND PAHO_CPP_TARGETS paho-mqttpp3-shared)

    ## Alias for subdirectory builds
    add_library(PahoMqttCpp::paho-mqttpp3-shared ALIAS paho-mqttpp3-shared)
    add_library(PahoMqttCpp::paho-mqttpp3 ALIAS paho-mqttpp3-shared)

    target_compile_definitions(paho-mqttpp3-shared PRIVATE PAHO_MQTTPP_EXPORTS)

    ## Add dependencies to the shared library
    target_link_libraries(paho-mqttpp3-shared PUBLIC
        ${PAHO_MQTT_C_LIB}
        Threads::Threads
        ${LIBS_SYSTEM}
    )

    ## set the shared library soname
    set_target_properties(paho-mqttpp3-shared PROPERTIES
        OUTPUT_NAME paho-mqttpp3
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
    )
endif()

## --- Build static version of the library, if requested ---

if(PAHO_BUILD_STATIC)
    ## Create the static library
    add_library(paho-mqttpp3-static STATIC ${COMMON_SRC})
    list(APPEND PAHO_CPP_TARGETS paho-mqttpp3-static)

    ## Alias for subdirectory builds
    add_library(PahoMqttCpp::paho-mqttpp3-static ALIAS paho-mqttpp3-static)

    ## Add dependencies to the static library
    target_link_libraries(paho-mqttpp3-static PUBLIC 
        ${PAHO_MQTT_C_LIB}-static
        Threads::Threads
        ${LIBS_SYSTEM}
    )

    if(${PAHO_BUILD_SHARED})
        # This lib should configure for static exports
        target_compile_definitions(paho-mqttpp3-static PRIVATE PAHO_MQTTPP_STATIC)
    else()
        # If no shared lib, make this one the default target
        add_library(PahoMqttCpp::paho-mqttpp3 ALIAS paho-mqttpp3-static)
    endif()

    ## Let the archive use the same base name as the shared lib on *nix systems
    if(UNIX)
        set_target_properties(paho-mqttpp3-static PROPERTIES OUTPUT_NAME paho-mqttpp3)
    endif()
endif()

## --- Set common properties, etc ---

include(GNUInstallDirs)

foreach(TARGET ${PAHO_CPP_TARGETS})
    set_target_properties(${TARGET} PROPERTIES
        CXX_STANDARD 17
        CXX_STANDARD_REQUIRED ON
        CXX_EXTENSIONS OFF
    )

    ## Build warnings
    target_compile_options(${TARGET} PRIVATE
        $<$<CXX_COMPILER_ID:MSVC>:/W3>
        $<$<CXX_COMPILER_ID:Clang>:-Wall -Wextra -Wdocumentation>
        $<$<NOT:$<OR:$<CXX_COMPILER_ID:MSVC>,$<CXX_COMPILER_ID:Clang>>>:-Wall -Wextra>
    )

    target_include_directories(${TARGET} PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    )

    ## install the shared library
    install(TARGETS ${TARGET} EXPORT PahoMqttCpp
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endforeach()

=== test/unit/CMakeLists.txt ===
# CMakeLists.txt
#
# CMake file for the Catch2 unit tests in the Eclipse Paho C++ library.
#

#*******************************************************************************
# Copyright (c) 2019-2023 Frank Pagliughi <fpagliughi@mindspring.com>
#
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v20.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Frank Pagliughi - Initial implementation
#*******************************************************************************/

# --- Find Catch2 and figure out which major version ---

find_package(Catch2 REQUIRED)

message(STATUS "Found Catch2 v${Catch2_VERSION}")

if (Catch2_VERSION VERSION_LESS "2.0")
    message(FATAL "Catch2 v2.0 or greater required for tests")
endif()

# --- Executables ---

add_executable(unit_tests unit_tests.cpp
    test_async_client.cpp
    test_buffer_ref.cpp
    test_client.cpp
    test_connect_options.cpp
    test_create_options.cpp
    test_disconnect_options.cpp
    test_exception.cpp
    test_message.cpp
    test_persistence.cpp
    test_properties.cpp
    test_response_options.cpp
    test_string_collection.cpp
    test_subscribe_options.cpp
    test_thread_queue.cpp
    test_token.cpp
    test_topic.cpp
    test_topic_matcher.cpp
    test_will_options.cpp
)

if(PAHO_WITH_SSL)
    target_sources(unit_tests PUBLIC 
        ${CMAKE_CURRENT_SOURCE_DIR}/test_ssl_options.cpp
    )
endif()

set_target_properties(unit_tests PROPERTIES
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
)

if (Catch2_VERSION VERSION_LESS "3.0")
    target_compile_definitions(unit_tests PUBLIC CATCH2_V2)
endif()

# --- Link for executables ---

target_link_libraries(unit_tests
    Catch2::Catch2
    PahoMqttCpp::paho-mqttpp3
)

if(PAHO_BUILD_SHARED)
    target_compile_definitions(unit_tests PUBLIC PAHO_MQTTPP_IMPORTS)

    if(MSVC AND PAHO_BUILD_STATIC)
        target_link_libraries(unit_tests ${LIBS_SYSTEM})
    endif()
endif()

include(CTest)
include(Catch)

catch_discover_tests(unit_tests)

=== debian/changelog ===
paho.mqtt.cpp (1.5.1-1) unstable; urgency=medium

  * New upstream version 1.5.1

 -- Roman Ondráček <mail@romanondracek.cz>  Mon, 10 Feb 2025 13:30:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: paho.mqtt.cpp
 Section: libs
 Priority: optional
-Maintainer: Matthias Klein <matthias@extraklein.de>
-Build-Depends: debhelper-compat (= 13), cmake, libssl-dev, libpaho-mqtt-dev (>= 1.3.8)
-Standards-Version: 4.5.1
-Homepage: https://github.com/eclipse/paho.mqtt.cpp/
-Vcs-Browser: https://salsa.debian.org/matthiasklein/paho.mqtt.cpp
-Vcs-Git: https://salsa.debian.org/matthiasklein/paho.mqtt.cpp.git
+Maintainer: Roman Ondráček <mail@romanondracek.cz>
+Build-Depends: debhelper-compat (= 13), cmake, doxygen, libcatch2-dev,
+ libssl-dev, libpaho-mqtt-dev (>= 1.3.14)
+Rules-Requires-Root: no
+Standards-Version: 4.7.0
+Homepage: https://github.com/eclipse-paho/paho.mqtt.cpp/
+Vcs-Browser: https://salsa.debian.org/ondracek/paho.mqtt.cpp
+Vcs-Git: https://salsa.debian.org/ondracek/paho.mqtt.cpp.git
 
 Package: libpaho-mqttpp3-1
-Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -32,3 +33,16 @@
  published messages.
  .
  This package contains the development files.
+
+Package: libpaho-mqttpp-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: Eclipse Paho MQTT C++ Client Library - library documentation
+ This library enables C++11 applications to connect to an MQTT broker,
+ publish messages to the broker, and to subscribe to topics and receive
+ published messages.
+ .
+ This package contains the doxygen generated HTML documentation for the
+ libraries.

## paho.mqtt.cpp 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,10 @@
 if(NOT PAHO_BUILD_SHARED AND NOT PAHO_BUILD_STATIC)
     message(FATAL_ERROR "You must set either PAHO_BUILD_SHARED, PAHO_BUILD_STATIC, or both")
 endif()
+
+# --- Setting naming variables ---
+
+set(PAHO_MQTTPP_GENERATED_DIR ${CMAKE_CURRENT_BINARY_DIR}/generated)
 
 ## --- Find Paho C or build it, if reqested ---
 
@@ -137,6 +141,15 @@
     add_subdirectory(test/unit)
 endif()
 
+## --- Install generated header(s) ---
+
+install(
+    DIRECTORY
+        ${PAHO_MQTTPP_GENERATED_DIR}/include/
+    DESTINATION
+        ${CMAKE_INSTALL_INCLUDEDIR}
+)
+
 ## --- Packaging settings ---
 
 if(WIN32)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,8 @@
 
 set (THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads REQUIRED)
+
+include(GenerateExportHeader)
 
 ## --- Use object library to optimize compilation ---
 
@@ -77,6 +79,11 @@
         VERSION ${PROJECT_VERSION}
         SOVERSION ${PROJECT_VERSION_MAJOR}
     )
+
+    generate_export_header(paho-mqttpp3-shared
+        BASE_NAME paho_mqttpp
+        EXPORT_FILE_NAME ${PAHO_MQTTPP_GENERATED_DIR}/include/mqtt/export.h
+    )
 endif()
 
 ## --- Build static version of the library, if requested ---
@@ -99,15 +106,27 @@
     if(${PAHO_BUILD_SHARED})
         # This lib should configure for static exports
         target_compile_definitions(paho-mqttpp3-static PRIVATE PAHO_MQTTPP_STATIC)
+        target_compile_definitions(paho-mqttpp3-static PRIVATE PAHO_MQTTPP_STATIC_DEFINE)
     else()
         # If no shared lib, make this one the default target
         add_library(PahoMqttCpp::paho-mqttpp3 ALIAS paho-mqttpp3-static)
+
+        generate_export_header(paho-mqttpp3-static
+            BASE_NAME paho_mqttpp
+            EXPORT_FILE_NAME ${PAHO_MQTTPP_GENERATED_DIR}/include/mqtt/export.h
+        )
     endif()
 
     ## Let the archive use the same base name as the shared lib on *nix systems
     if(UNIX)
         set_target_properties(paho-mqttpp3-static PROPERTIES OUTPUT_NAME paho-mqttpp3)
     endif()
+endif()
+
+## --- Make sure at least one target was specified ---
+
+if(NOT PAHO_CPP_TARGETS)
+    message(FATAL_ERROR "No build targets are specified")
 endif()
 
 ## --- Set common properties, etc ---

=== debian/changelog ===
paho.mqtt.cpp (1.5.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Mon, 31 Mar 2025 10:24:57 -0400

paho.mqtt.cpp (1.5.2-1) unstable; urgency=medium

  * d/control: update standards version to 4.7.2
  * New upstream version 1.5.2

 -- Roman Ondráček <mail@romanondracek.cz>  Tue, 11 Mar 2025 21:45:02 +0100

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DPAHO_BUILD_DEB_PACKAGE=FALSE \
		-DPAHO_BUILD_DOCUMENTATION=TRUE \
		-DPAHO_BUILD_SHARED=TRUE \
		-DPAHO_BUILD_STATIC=TRUE \
		-DPAHO_BUILD_SAMPLES=FALSE \
		-DPAHO_BUILD_TESTS=FALSE \
		-DPAHO_WITH_SSL=TRUE

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?\/)?v?(\d[\d.]*)\.tar\.gz/${PACKAGE}_\$1.orig.tar.gz/" \
    https://github.com/eclipse-paho/paho.mqtt.cpp/tags (?:.*?\/)?v?(\d[\d.]*)\.tar\.gz

## paho.mqtt.cpp 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 cmake_minimum_required(VERSION 3.13)
 
-project(PahoMqttCpp VERSION "1.5.1")
+project(PahoMqttCpp VERSION "1.5.3")
 
 ## --- Build options ---
 
@@ -71,6 +71,7 @@
     if(NOT WIN32)
         set(PAHO_WITH_UNIX_SOCKETS TRUE CACHE BOOL "Support for Unix-domain sockets")
     endif()
+    set(CMAKE_C_STANDARD 99 CACHE STRING "Paho C language standard")
 
     add_subdirectory(${PROJECT_SOURCE_DIR}/externals/paho-mqtt-c)

=== dist/Makefile ===
VERSION=1.0.0

check:
	rpmlint -i dist/paho-cpp.spec

rpm-prep:
	mkdir -p ${HOME}/rpmbuild/SOURCES/
	tar --transform="s/\./paho-cpp-${VERSION}/" -cf ${HOME}/rpmbuild/SOURCES/v${VERSION}.tar.gz --exclude=./build.paho.cpp --exclude=.git --exclude=*.bz ./ --gzip

rpm: rpm-prep
	rpmbuild -ba dist/paho-cpp.spec

=== doc/CMakeLists.txt ===
#*******************************************************************************
# Copyright (c) 2024, Frank Pagliughi
# Copyright (c) 2016, Guilherme Maciel Ferreira
# 
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v20.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Frank Pagliughi - Updated paths. Fixed conflict with Paho C
#     Guilherme Maciel Ferreira - initial version
#*******************************************************************************/

## documentation settings
find_package(Doxygen REQUIRED)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)

message(STATUS "Doxygen: ${DOXYGEN_EXECUTABLE}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY
)

add_custom_target(
    paho-mqttpp3-doc.target
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM
)

add_custom_target(paho-mqttpp3-doc ALL 
    DEPENDS paho-mqttpp3-doc.target
)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/
    DESTINATION share/doc/EclipsePahoCpp
)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
     async_publish
     async_publish_time
     async_subscribe
+    async_subscribe_v5
     async_consume
     async_consume_v5
     async_message_consume

=== include/mqtt/CMakeLists.txt ===
#*******************************************************************************
#  Copyright (c) 2016-2024  Frank Pagliughi <fpagliughi@mindspring.com>
# 
#  All rights reserved. This program and the accompanying materials
#  are made available under the terms of the Eclipse Public License v2.0
#  and Eclipse Distribution License v1.0 which accompany this distribution. 
# 
#  The Eclipse Public License is available at 
#     http://www.eclipse.org/legal/epl-v20.html
#  and the Eclipse Distribution License is available at 
#    http://www.eclipse.org/org/documents/edl-v10.php.
# 
#  Contributors:
#     Guilherme Maciel Ferreira - initial version
#     Frank Pagliughi - updates throughout
#*******************************************************************************/

install(
    FILES
        async_client.h
        buffer_ref.h
        buffer_view.h
        callback.h
        client.h
        connect_options.h
        create_options.h
        delivery_token.h
        disconnect_options.h
        event.h
        exception.h
        export.h
        iaction_listener.h
        iasync_client.h
        iclient_persistence.h
        message.h
        platform.h
        properties.h
        reason_code.h
        response_options.h
        server_response.h
        ssl_options.h
        string_collection.h
        subscribe_options.h
        thread_queue.h
        token.h
        topic_matcher.h
        topic.h
        types.h
        will_options.h
    DESTINATION 
        include/mqtt
)

=== debian/changelog ===
paho.mqtt.cpp (1.5.3-1) unstable; urgency=medium

  * New upstream version 1.5.3

 -- Roman Ondráček <mail@romanondracek.cz>  Mon, 18 Aug 2025 00:30:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13), cmake, doxygen, libcatch2-dev,
  libssl-dev, libpaho-mqtt-dev (>= 1.3.14)
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/eclipse-paho/paho.mqtt.cpp/
 Vcs-Browser: https://salsa.debian.org/ondracek/paho.mqtt.cpp
 Vcs-Git: https://salsa.debian.org/ondracek/paho.mqtt.cpp.git
